C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        INTEGER FUNCTION INIT3 ( )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: INIT3
!DEC$ ENDIF
C***********************************************************************
C  subroutine body starts at line  63
C
C  FUNCTION:  Initialize state for netCDF/FORTRAN implementation
C             of Models-3 I/O.  May be called multiple times 
C             whenever the caller wants the unit number for the
C             log file.
C
C  RETURN VALUE:  unit number for the log file
C
C  PRECONDITIONS REQUIRED:  none
C
C  SUBROUTINES AND FUNCTIONS CALLED:  NAMEVAL()
C
C  REVISION  HISTORY:
C       prototype 3/92 by CJC
C       Modified  8/95 by CJC to support CLOSE3()
C       Modified  4.96 by CJC to open SCENFILE first time only.
C       Modified  5/96 by CJC                
C***********************************************************************

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'NETCDF.EXT'
        INCLUDE 'PARMS3.EXT'
        INCLUDE 'STATE3.EXT'


C...........   EXTERNAL FUNCTIONS and their descriptions:

        INTEGER         JUNIT, TRIMLEN
        EXTERNAL        INITBLK3, JUNIT, TRIMLEN


C...........   SAVED LOCAL VARIABLES and their descriptions:
C...........   NOTE:  the ANSI standard requires the use of SAVE statements
C...........   for variables which must retain their values from call to call.

        CHARACTER*16    LOGFILE
        DATA            LOGFILE / 'LOGFILE         ' /

        CHARACTER*16    SCENFILE
        DATA            SCENFILE / 'SCENFILE        ' /

        SAVE            LOGFILE, SCENFILE


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        CHARACTER*120   EQNAME
        INTEGER         I, J, IOST, IDEV
        LOGICAL         AFLAG

        CHARACTER *80 LIBVER
        PARAMETER (   LIBVER = '$' //
     &             'Id: @(#) ioapi library version 1.9.2'
!    &             // VERSION
!$   &             // ' OpenMP enabled'
     &             // ' $' )
        CHARACTER *80 IOAPILIBVER
!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef IOAPICPL
        CHARACTER *80 IOCPLLIBVER
        CHARACTER *80 PVMLIBVER
#endif
!DEC$ ENDIF

C***********************************************************************
C   begin body of subroutine  INIT3


        IF ( FINIT3 ) THEN
            INIT3 = LOGDEV
            RETURN           !  M3 I/O already set up
        END IF

        IF ( LOGDEV .LT. 0 ) THEN

!$OMP       CRITICAL( S_NC )
            CALL NCPOPT( NCVERBOS )
!$OMP       END CRITICAL( S_NC )

            CALL NAMEVAL( LOGFILE, EQNAME )
            IF ( LOGFILE .EQ. EQNAME(1:16 ) ) THEN

                LOGDEV = 6

            ELSE IF ( EQNAME .EQ. '/dev/null' ) THEN

                LOGDEV = JUNIT()
                OPEN ( UNIT    =  LOGDEV,
     &                 IOSTAT  =  IOST,
     &                 FILE    =  EQNAME,
     &                 ACCESS  =  'SEQUENTIAL')

                IF ( IOST .NE. 0 ) THEN
                    WRITE( *,91010 )
     &                      'Error opening log file on unit', LOGDEV,
     &                      'File: ', EQNAME
                    CALL EXIT( 2 )
                END IF

            ELSE

                LOGDEV = JUNIT()
                OPEN ( UNIT    =  LOGDEV,
     &                 IOSTAT  =  IOST,
     &                 FILE    =  EQNAME,
     &                 STATUS  =  'NEW',
     &                 ACCESS  =  'SEQUENTIAL')

                IF ( IOST .NE. 0 ) THEN
                    WRITE( *,91010 )
     &                      'Error opening log file on unit', LOGDEV,
     &                      'File: ', EQNAME
                    CALL EXIT( 2 )
                END IF

            END IF

!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef IOAPICPL
        CALL GET_IOCPL_VERSION( IOCPLLIBVER )
        CALL GET_PVM_VERSION  ( PVMLIBVER )
#endif
!DEC$ ENDIF
        IOAPILIBVER = LIBVER

            WRITE( LOGDEV,92000 ) ' ',
     &  'This program uses the EPA-AREAL/MCNC-Environmental Programs' ,
     &  'Models-3 I/O Applications Programming Interface, which is '  ,
     &  'built on top of the netCDF I/O library (Copyright 1993, 1996',
     &  'University Corporation for Atmospheric Research/Unidata '    ,
     &  'Program).  Portions copyright (C) 1992-1999 MCNC.  See URL' , 
     &  '"http://envpro.ncsc.org/products/ioapi/H.NOTICE.html" for',
     &  'conditions of use.',
     &  ' ',
     &  IOAPILIBVER( 1:TRIMLEN( IOAPILIBVER ) )
!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef IOAPICPL
            WRITE( LOGDEV,92000 ) ' ',
     &  'IOCPL version '// IOCPLLIBVER( 1:TRIMLEN( IOCPLLIBVER ) ),
     &  'PVM   version '// PVMLIBVER(   1:TRIMLEN( PVMLIBVER ) )
#endif
!DEC$ ENDIF

CJEB   NOTE: on Digital Visual Fortran cannot have compiler directives
CJEB         within a WRITE statement

            IF ( LOGDEV .NE. 6 ) THEN
                WRITE( *,92000 ) 
     &  ' ',
     &  'This program uses the EPA-AREAL/MCNC-Environmental Programs' ,
     &  'Models-3 I/O Applications Programming Interface, which is '  ,
     &  'built on top of the netCDF I/O library (Copyright 1993, 1996',
     &  'University Corporation for Atmospheric Research/Unidata '    ,
     &  'Program).  Portions copyright (C) 1992-1999 MCNC.  See URL' , 
     &  '"http://envpro.ncsc.org/products/ioapi/H.NOTICE.html" for',
     &  'conditions of use.',
     &  ' ',
     &  IOAPILIBVER( 1:TRIMLEN( IOAPILIBVER ) )
!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef IOAPICPL
                WRITE( *,92000 ) 
     &  'IOCPL version '// IOCPLLIBVER( 1:TRIMLEN( IOCPLLIBVER ) ),
     &  'PVM   version '// PVMLIBVER(   1:TRIMLEN( PVMLIBVER ) )
#endif
!DEC$ ENDIF
            END IF

        WRITE(LOGDEV, 92000) ' '

            CALL NAMEVAL( SCENFILE, EQNAME )
            INQUIRE ( FILE = EQNAME, EXIST = AFLAG )

            IF ( AFLAG ) THEN

                IDEV = JUNIT( )
                OPEN ( UNIT    =  IDEV,
     &                 IOSTAT  =  IOST,
     &                 FILE    =  EQNAME,
     &                 STATUS  =  'OLD',
     &                 ACCESS  =  'SEQUENTIAL' ,
     &                 FORM    =  'FORMATTED' )
                IF ( IOST .NE. 0 ) THEN
                    WRITE( LOGDEV,91020 )
     &              'Error opening scenario file.  Error number', 
     &              IOST,
     &              'File: ', EQNAME
                    GO TO  12
                END IF
                DO  11  I = 1 , MXDESC3
                    READ( IDEV, 93010, END=12, IOSTAT=IOST ) 
     &                  SCNDSC( I )
                    IF ( IOST .NE. 0 ) THEN
                        WRITE( LOGDEV,91020 )
     &                  'Error reading scenario file.  Error number', 
     &                  IOST,
     &                  'File: ', EQNAME
                        GO TO  12   ! escape this loop
                    END IF
11              CONTINUE
12              CONTINUE            ! target of loop-escape

                CLOSE( IDEV )

            END IF          !  if aflag:  scenfile exists

            CALL NAMEVAL( 'EXECUTION_ID', EXECN3 )
            IF ( EXECN3( 1:12 ) .EQ. 'EXECUTION_ID' ) THEN
                EXECN3 = CMISS3
            END IF

        END IF		!  if logdev < 0


        DO  22  J = 1, MXFILE3
            DO  21  I = 1, MXVARS3
                LDATE3( I,J ) = IMISS3  !  "invalid"
                LTIME3( I,J ) = IMISS3  !  "invalid"
                NDATE3( I,J ) = IMISS3  !  "invalid"
                NTIME3( I,J ) = IMISS3  !  "invalid"
21          CONTINUE
            BSIZE3( J ) = IMISS3  !  "invalid"
            FLIST3( J ) = CMISS3  !  "invalid"
22      CONTINUE


        CALL GETDTTIME ( CURDATE, CURTIME )   


        IF ( COUNT3 .LT. 0 ) THEN
            WRITE( LOGDEV,91030 )
     &                  'INIT3() called subsequent to SHUT3()'
        END IF

        FINIT3 = .TRUE.
        COUNT3 = 0
        INIT3  = LOGDEV

        RETURN


C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91010   FORMAT ( //5X , '*** ERROR ABORT in subroutine INIT3 ***',
     &            /5X , A , I3,
     &            /5X , A , A , // )

91020   FORMAT ( //5X , '>>> WARNING in subroutine INIT3 <<<',
     &            /5X , A , I3,
     &            /5X , A , A , // )

91030   FORMAT ( //5X , '>>> WARNING in subroutine INIT3 <<<',
     &            /5X , A , I3,
     &            /5X , A , A , // )


C...........   Log Message formats................... 92xxx

92000   FORMAT( 5X, A )


C...........   Formatted file I/O formats............ 93xxx

93010   FORMAT ( A )


        END

