
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        SUBROUTINE  M3WARN( CALLER, JDATE, JTIME, MSGTXT )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: M3WARN
!DEC$ ENDIF
C***********************************************************************
C  subroutine body starts at line  57
C
C  FUNCTION:  Generate simple warning messages for Models-3 core;
C
C  PRECONDITIONS REQUIRED:  
C	JDATE:JTIME represented as YYYYDDD:HHMMSS, or 0 if not relevant
C
C  SUBROUTINES AND FUNCTIONS CALLED:  DT2STR, INIT3
C
C  REVISION  HISTORY:	
C	adapted   9/95 by CJC from M3ERR()
C       modified  1/97 by CJC to trim trailing blanks from MSGTXT
C       modified 10/98 by CJC:  Factor all output through m3msg2(), to
C                      get around SGI OpenMP bug.
C                      Caution:  messages may not be sequenced correctly
C                      when called by multiple threads simultaneously
C***********************************************************************

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'IODECL3.EXT'


C...........   ARGUMENTS and their descriptions:

        CHARACTER*(*)   CALLER          !  name of the caller
        INTEGER         JDATE, JTIME    !  model date&time for the error
        CHARACTER*(*)   MSGTXT          !  error message

                 
C...........   EXTERNAL FUNCTIONS and their descriptions:

        CHARACTER*24    DT2STR
        EXTERNAL        DT2STR


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        CHARACTER*256   MESG


C***********************************************************************
C   begin body of subroutine  M3WARN

        MESG = '>>--->> WARNING in subroutine ' // CALLER
        CALL M3MSG2( MESG )
        CALL M3MSG2( MSGTXT )

        IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
            MESG = 'M3WARN:  DTBUF ' // DT2STR( JDATE, JTIME )
            CALL M3MSG2( MESG )
        END IF

        RETURN

        END

