
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................


        PROGRAM M3FAKE

C***********************************************************************
C  subroutine body starts at line  135
C
C  FUNCTION:
C	Generate new EDSS/Models-3 I/O API file with the user-sepcified
C	structure and "fake" data.
C
C  PRECONDITIONS REQUIRED:
C	none
C
C  SUBROUTINES AND FUNCTIONS CALLED:
C	FAKESTEP
C
C  REVISION  HISTORY:
C	prototype 8/95 by CJC
C
C***********************************************************************

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'PARMS3.EXT'  !  I/O parameter definitions
        INCLUDE 'FDESC3.EXT'  !  file header data structures
        INCLUDE 'IODECL3.EXT' !  I/O definitions and declarations


C...........   EXTERNAL FUNCTIONS and their descriptions:

        LOGICAL          GETYN
        LOGICAL          DSCGRID
        CHARACTER*16     PROMPTMFILE
        INTEGER          GETMENU, GETNUM, IARGC, INDEX1,
     &                   SECSDIFF, SEC2TIME, TIME2SEC, TRIMLEN
        REAL             GETREAL
        DOUBLE PRECISION GETDBLE

        EXTERNAL  GETDBLE, GETMENU, GETNUM, GETREAL, GETYN, IARGC, 
     &            INDEX1, DSCGRID, PROMPTMFILE, SECSDIFF, SEC2TIME,
     &            TIME2SEC, TRIMLEN


C...........   PARAMETERS and their descriptions:

        DOUBLE PRECISION SIXTH
        PARAMETER      ( SIXTH = 1.0D0 / 6.0D0 )


C...........   EXTERNAL FUNCTIONS and their descriptions:


C...........   LOCAL VARIABLES and their descriptions:

        INTEGER		IDUM	!  value from INIT3()
        CHARACTER*60    AMENU( 5 )
        DATA            AMENU
     &  /
     &  'Column   number (1...NCOLS)',
     &  'Row      number (1...NROWS)',
     &  'Layer    number (1...NLAYS)',
     &  'Timestep number (1...NSTEPS)',
     &  'User-specified fill value'
     &  /
        INTEGER		ATYPES( 5 ) 
        DATA            ATYPES      / 1, 2, 3, 4, 5 /
        INTEGER		OPTYPES( MXVARS3 )
        REAL		FILLVAL( MXVARS3 )

        CHARACTER*60    FMENU( 7 )
        DATA            FMENU
     &  /
     &  'File type CUSTOM',
     &  'File type GRIDDED',
     &  'File type BOUNDARY',
     &  'File type IDDATA',
     &  'File type PROFILE',
     &  'File type GRID-NEST',
     &  'File type SPARSE MATRIX'
     &  /
        INTEGER          FTYPES( 7 )
        DATA             FTYPES
     &  /CUSTOM3, GRDDED3, BNDARY3, IDDATA3, PROFIL3, GRNEST3, SMATRX3/

        CHARACTER*60    VMENU( 3 )
        DATA            VMENU
     &  /
     &  'Primitive data type REAL',
     &  'Primitive data type DOUBLE PRECISION',
     &  'Primitive data type INTEGER'
     &  /
        INTEGER          VTYPES( 3 ) 
        DATA             VTYPES  / M3REAL, M3DBLE, M3INT /

        CHARACTER*60    GMENU( 6 )
        DATA            GMENU
     &  /
     &  'Map projection type LAT-LON',
     &  'Map projection type LAMBERT',
     &  'Map projection type MERCATOR( general)',
     &  'Map projection type STEREOGRAPHIC',
     &  'Map projection type UTM',
     &  'Map projection type MISSING or NOT APPLICABLE'
     &  /
        INTEGER         GTYPES( 6 )
        DATA            GTYPES
     &  / LATGRD3, LAMGRD3, MERGRD3, STEGRD3, UTMGRD3, IMISS3 /

        CHARACTER*60    VGMENU( 7 )
        DATA            VGMENU
     &  /
     &  'Vertical coordinate type PRESSURE (mb)',
     &  'Vertical coordinate type Z (height a.g.l., m)',
     &  'Vertical coordinate type H (height a.s.l., m)',
     &  'Vertical coordinate type HYDROSTATIC SIGMA-P',
     &  'Vertical coordinate type NONHYDROSTATIC SIGMA-P',
     &  'Vertical coordinate type SIGMA-Z',
     &  'Vertical coordinate type MISSING or NOT APPLICABLE'
     &  /
        INTEGER          VGTYPES( 7 )
        DATA             VGTYPES
     &  /VGPRES3, VGZVAL3, VGHVAL3, VGSGPH3, VGSGPN3, VGSIGZ3, IMISS3/


        INTEGER        V, L, T
        INTEGER        NSTEPS, JDATE, JTIME, TSTEP
        INTEGER        ARGCNT
        CHARACTER*16   FNAME, CNAME
        CHARACTER*80   MESG
        CHARACTER*256   ENVBUF  !  value from command line arguments
        

C***********************************************************************
C   begin body of program M3FAKE

        WRITE( *,92000 ) 
     &  ' ', ' ', ' ',
     &  'Program "M3FAKE" to create "dummied-up" files according to',
     &  'the user-specified file description.  Before running the ',
     &  'program, you need to have assigned an appropriate path name',
     &  'for the output file (using "setenv <lname> <plathname>).  ',
     &  'You will be asked for the logical name and the specifications',
     &  'for the input file.',
     &  ' ',
     &  'Usage:  "m3fake [<lname>]"',
     &  ' ',
     &  'NOTE:  Presently, only CUSTOM, GRIDDED, and BOUNDARY files',
     &  'are supported, although support for others will be added.',
     &  'in the future.',
     &  ' '
        IF ( .NOT.GETYN( 'Continue with program?', .TRUE. ) ) 
     &          CALL M3EXIT( 'M3FAKE', 0, 0, 'Program aborted', 2 )
        IDUM = INIT3()

        WRITE( *,92000 )
     &  ' ', 
     &  'First, let us define the file type and get the dimensions.',
     &  ' '

        FTYPE3D = FTYPES( GETMENU( 3, 2,  'Enter file type', FMENU ) )


C...............   Get file, grid description:

        WRITE( *,95000 ) 'Enter the grid/coord system name >> '
        READ ( *,93000 ) GDNAM3D

        IF ( DSCGRID( GDNAM3D, CNAME, GDTYP3D,      !  "standard" grid name
     &                P_ALP3D, P_BET3D, P_GAM3D, 
     &                XCENT3D, YCENT3D, XORIG3D, YORIG3D, 
     &                XCELL3D, YCELL3D, 
     &                NCOLS3D, NROWS3D, NTHIK3D ) ) THEN

            IF( FTYPE3D .EQ. CUSTOM3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 'Enter BLOBSIZE' )

            ELSE IF( FTYPE3D .EQ. IDDATA3 ) THEN

                NCOLS3D = IMISS3
                NROWS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter NUMBER OF SITES' )
                   
            ELSE IF( FTYPE3D .EQ. PROFIL3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter MAX LEVEL-COUNT' )
                NROWS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter NUMBER OF SITES' )

            ELSE IF( FTYPE3D .EQ. GRNEST3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 10, 
     &                            'Enter MAX NEST-COUNT' )
                NROWS3D = GETNUM( 1, 1999999999, 1000, 
     &                            'Enter NUMBER OF CELLS PER NEST' )

            ELSE IF( FTYPE3D .EQ. SMATRX3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 10000, 
     &                            'Enter MAX NUMBER OF COEFFS' )
                NROWS3D = GETNUM( 1, 1999999999, 1000,
     &                            'Enter number of matrix rows' )

            END IF		!  through ftype3d's (where dscgrid() worked)

        ELSE		!  else dscgrid() failed

            IF( FTYPE3D .EQ. CUSTOM3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 'Enter BLOBSIZE' )
                NROWS3D = IMISS3
                NTHIK3D = IMISS3

            ELSE IF( FTYPE3D .EQ. GRDDED3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter number of GRID COLUMNS' )
                NROWS3D = GETNUM( 1, 1999999999, 100,
     &                            'Enter number of GRID ROWS' )
                NTHIK3D = IMISS3

            ELSE IF( FTYPE3D .EQ. BNDARY3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter number of GRID COLUMNS' )
                NROWS3D = GETNUM( 1, 1999999999, 100,
     &                            'Enter number of GRID ROWS' )
                NTHIK3D = MIN( NCOLS3D / 2, NROWS3D / 2 ) - 1
                NTHIK3D = GETNUM( -NTHIK3D, NTHIK3D, 1,
     &                            'Enter PERIMETER THICKNESS (cells)' )

            ELSE IF( FTYPE3D .EQ. IDDATA3 ) THEN

                NCOLS3D = IMISS3
                NROWS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter NUMBER OF SITES' )
                NTHIK3D = IMISS3

            ELSE IF( FTYPE3D .EQ. PROFIL3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter MAX LEVEL-COUNT' )
                NROWS3D = GETNUM( 1, 1999999999, 100, 
     &                            'Enter NUMBER OF SITES' )
                NTHIK3D = IMISS3

            ELSE IF( FTYPE3D .EQ. GRNEST3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 10, 
     &                            'Enter MAX NEST-COUNT' )
                NROWS3D = GETNUM( 1, 1999999999, 1000, 
     &                            'Enter NUMBER OF CELLS PER NEST' )
                NTHIK3D = IMISS3

            ELSE IF( FTYPE3D .EQ. SMATRX3 ) THEN

                NCOLS3D = GETNUM( 1, 1999999999, 10000, 
     &                            'Enter MAX NUMBER OF COEFFS' )
                NROWS3D = GETNUM( 1, 1999999999, 1000,
     &                            'Enter number of matrix rows' )
                NTHIK3D = IMISS3

            END IF		!  through all the ftype3d's

            WRITE( *,92000 )
     &      ' ', 
     &      'Next, let us construct the horizontal coordinate system',
     &      '("map projection") for the file', ' '
                   
            GDTYP3D = GTYPES( GETMENU( 6, 2, 
     &                                 'Enter coordinate system type',
     &                                 GMENU ) )

            IF ( GDTYP3D .EQ. LATGRD3 ) THEN

                XCELL3D = GETDBLE( 0.0D0, 1.0D36, 0.25D0,
     &                             'Enter cell size DX (deg.N)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, SIXTH,
     &                             'Enter cell size DY (deg.E)' )
                XORIG3D = -99.0D0
                YORIG3D =  27.0D0

            ELSE IF ( GDTYP3D .EQ. LAMGRD3 ) THEN

                P_ALP3D = GETDBLE( -90.0D0, 90.0D0, 30.0D0,
     &                             'Enter first  latitude for cone' )
                P_BET3D = GETDBLE( P_ALP3D, 90.0D0, 60.0D0,
     &                             'Enter second latitude for cone' )
                P_GAM3D = GETDBLE( -180.0D0, 180.0D0, -90.0D0,
     &                             'Enter central longitude for cone' )
                XCENT3D = GETDBLE( -180.0D0, 180.0D0, P_GAM3D,
     &                             'Enter longitude for X-Y origin' )
                YCENT3D = GETDBLE( P_ALP3D, P_BET3D, 
     &                             0.5D0 * ( P_ALP3D + P_BET3D ),
     &                             'Enter latitude for X-Y origin' )
                XCELL3D = GETDBLE( 0.0D0, 1.0D36, 540000.0D0,
     &                             'Enter cell size DX (m)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, 540000.0D0,
     &                             'Enter cell size DY (m)' )
                XORIG3D = XCELL3D * DBLE( -NCOLS3D / 2 )
                YORIG3D = YCELL3D * DBLE( -NROWS3D / 2 )

            ELSE IF ( GDTYP3D .EQ. MERGRD3 ) THEN

                P_ALP3D = GETDBLE( -90.0D0, 90.0D0, 30.0D0,
     &                    'Enter latitude  for cylinder origin' )
                P_BET3D = GETDBLE( -180.0D0, 180.0D0, -90.0D0,
     &                    'Enter longitude for cylinder origin' )
                P_GAM3D = GETDBLE( -180.0D0, 180.0D0, -90.0D0,
     &                    'Enter angle between axis and N pole' )
                XCENT3D = GETDBLE( 0.0D0, 90.0D0, 30.0D0,
     &                    'Enter latitude for X-Y origin' )
                YCENT3D = GETDBLE( -180.0D0, 180.0D0, -90.0D0,
     &                    'Enter longitude for X-Y origin' )
                XCELL3D = GETDBLE( 0.0D0, 1.0D36, 50000.0D0,
     &                    'Enter cell size DX (m)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, 50000.0D0,
     &                    'Enter cell size DY (m)' )
                XORIG3D = XCELL3D * DBLE( -NCOLS3D / 2 )
                YORIG3D = YCELL3D * DBLE( -NROWS3D / 2 )

          ELSE IF ( GDTYP3D .EQ. STEGRD3 ) THEN

                P_ALP3D = GETDBLE( -90.0D0, 90.0D0, 60.0D0,
     &                    'Enter latitude for point of tangency' )
                P_BET3D = GETDBLE( -180.0D0, 180.0D0, -90.0D0,
     &                    'Enter longitude for point of tangency')
                P_GAM3D = GETDBLE( -180.0D0, 180.0D0, 0.0D0,
     &                    'Enter angle between Y and true N at origin')
                XCENT3D = GETDBLE( 0.0D0, 90.0D0, P_ALP3D,
     &                    'Enter latitude for X-Y origin' )
                YCENT3D = GETDBLE( -180.0D0, 180.0D0, P_BET3D,
     &                    'Enter longitude for X-Y origin' )
                XCELL3D = GETDBLE( 0.0D0, 1.0D36, 50000.0D0,
     &                    'Enter cell size DX (m)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, 50000.0D0,
     &                    'Enter cell size DY (m)' )
                XORIG3D = XCELL3D * DBLE( -NCOLS3D / 2 )
                YORIG3D = YCELL3D * DBLE( -NROWS3D / 2 )

            ELSE IF ( GDTYP3D .EQ. UTMGRD3 ) THEN

                P_ALP3D = DBLE( GETNUM( 1, 36, 17, 'Enter UTM zone' ) )
                P_BET3D = DBLE( BADVAL3 )
                P_GAM3D = DBLE( BADVAL3 )
                XCENT3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ), 
     &                    0.0D0,
     &                    'Enter UTM X offset for origin (m)' )
                YCENT3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ), 
     &                    0.0D0,
     &                    'Enter UTM Y offset for origin (m)' )
                XCELL3D = GETDBLE( 0.0D0, 1.0D36, 5000.0D0,
     &                    'Enter cell size DX (m)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, 5000.0D0,
     &                    'Enter cell size DY (m)' )
                XORIG3D =  350.0D3
                YORIG3D = 3785.0D3

        ELSE    

                WRITE( *,92000 )
     &          ' ', 
     &          'Grid/coordinate type:  "UNKNOWN" or "MISSING"',
     &          ' '
                P_ALP3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ), 
     &                             0.0D0, 
     &                             'Enter projection parameter ALPHA' )
                P_BET3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ), 
     &                             0.0D0,
     &                             'Enter projection parameter BETA ' )
                P_GAM3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ),
     &                             0.0D0,
     &                             'Enter projection parameter GAMMA' )
                XCENT3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ),
     &                             0.0D0,
     &                             'Enter X-Y origin' )
                YCENT3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ),
     &                             0.0D0,
     &                             'Enter X-Y origin' )
                XCELL3D = GETDBLE( DBLE( BADVAL3 ), -DBLE( BADVAL3 ),
     &                             0.0D0,
     &                             'Enter cell size DX (m)' )
                YCELL3D = GETDBLE( 0.0D0, 1.0D36, 50000.0D0,
     &                             'Enter cell size DY (m)' )
                XORIG3D = 0.0D0
                YORIG3D = 0.0D0

            END IF		!  through grdtyp3d's (where dscgrid failed)

            XORIG3D = GETDBLE( -1.0D36, 1.0D36, XORIG3D,
     &                         'Enter starting grid corner X' )
            YORIG3D = GETDBLE( -1.0D36, 1.0D36, YORIG3D,
     &                         'Enter starting grid corner Y' )

        END IF            !  if dscgrid() worked, or not


C...............   Get vertical structure description:
        
        WRITE( *,92000 )
     &  ' ', 
     &  'Next, let us construct the vertical coordinate system ',
     &  'for the file', 
     &  ' '

        NLAYS3D = GETNUM( 1, MXLAYS3, 30, 'Enter number of layers' )

        IF ( NLAYS3D .GT. 1 ) THEN

            VGTYP3D = VGTYPES( GETMENU( 7, 4, 
     &                         'Enter vertical coordinate type',
     &                         VGMENU ) )

            IF ( ( VGTYP3D .EQ. VGSGPH3 ) .OR. 
     &           ( VGTYP3D .EQ. VGSGPN3 ) .OR. 
     &           ( VGTYP3D .EQ. VGSIGZ3 )    ) THEN
                VGTOP3D = GETREAL( 0.0, 9.99E36, 100.0,
     &                    'Enter MODEL TOP for sigma coordinate' )
            ELSE
                VGTOP3D = BADVAL3
            END IF
            DO  22  L = 1, NLAYS3D+1
                WRITE( MESG,94000 ) 'Enter value for layer', L-1
                VGLVS3D( L ) = GETREAL( 0.0, 9.99E36, 0.0, MESG )
22          CONTINUE
            DO  23  L = NLAYS3D+2, MXLAYS3
                VGLVS3D( L ) = BADVAL3
23          CONTINUE

        ELSE

            VGTYP3D = IMISS3
            VGTOP3D = BADVAL3
            DO  24  L = 0,MXLAYS3
                VGLVS3D( L ) = BADVAL3
24          CONTINUE

        END IF		!  if nlays3d > 1, or not
        

C...............   Get timestep structure:

        WRITE( *,92000 )
     &  ' ', 
     &  'Next, let us construct the time step structure for the file',
     &  '    TSTEP > 0:  "timestepped" file;',
     &  '    TSTEP = 0   "time-independent" file;',
     &  '    TSTEP > 0   "circular-buffer" file.', ' '

        TSTEP3D = GETNUM( -999999999, 999999999, 10000,
     &                    'Enter TSTEP (hhmmss)' )
        IF ( TSTEP3D .EQ. 0 ) THEN
            SDATE3D = 0
            STIME3D = 0
            NSTEPS  = 1
        ELSE
            SDATE3D = GETNUM( 1900000, 9999366, 1988200,
     &                        'Enter STARTING DATE (yyyyddd)' )
            STIME3D = GETNUM( 0, 235959, 0,
     &                        'Enter STARTING TIME (hhmmss)' )
            NSTEPS = GETNUM( 0, 999999, 24, 
     &                       'Enter number of time steps' )
        END IF
            
        JDATE = SDATE3D
        JTIME = STIME3D
        TSTEP = TSTEP3D


C...............   Get variables and their descriptions:

        NVARS3D = GETNUM( 0, MXVARS3, 1,
     &                    'Enter number of variables' )

        WRITE( *,92000 )
     &  ' ', 
     &  'Now enter the variable descriptions',
     &  ' '
        DO  11  V = 1, NVARS3D

            WRITE( MESG,94000 ) 'Enter NAME for variable', V, ' > ' 
            WRITE( *,95000 ) MESG ( 1 : 1+TRIMLEN( MESG ) )
            READ(  *,93000 ) VNAME3D( V )

            WRITE( MESG,94000 ) 'Enter UNITS for variable', V, ' > ' 
            WRITE( *,95000 ) MESG ( 1 : 1+TRIMLEN( MESG ) )
            READ(  *,93000 ) UNITS3D( V )

            WRITE( MESG,94000 ) 
     &              'Enter DESCRIPTION for variable', V, ' > '
            WRITE( *,95000 ) MESG ( 1 : 1+TRIMLEN( MESG ) )
            READ(  *,93000 ) VDESC3D( V )

            WRITE( MESG,94000 ) 'Enter TYPE for variable', V
            VTYPE3D( V ) = VTYPES( GETMENU( 3, 1, MESG, VMENU ) )

            WRITE( MESG,94000 ) 'Enter FILLER FORMULA for variable', V
            OPTYPES( V ) = ATYPES( GETMENU( 5, 1, MESG, AMENU ) )
            IF ( OPTYPES( V ) .EQ. 5 ) THEN
                FILLVAL( V ) = GETREAL( BADVAL3, -BADVAL3, 0.0,
     &                                  'Enter fill value' )
            END IF

11      CONTINUE

        WRITE( *,92000 )
     &  ' ', 
     &  'Now enter the file description (end with a BLANK LINE)',
     &  ' '

        DO 44 L = 1, MXDESC3
            WRITE( *,95000 ) ' > '
            READ ( *,93000, END=45 ) FDESC3D( L )
            IF ( FDESC3D( L ) .EQ. ' ' ) THEN
                GO TO  46
            END IF
44      CONTINUE
45      CONTINUE
        CALL FLUSH( 5 )
46      CONTINUE
         
C...........   Open output file (prompting as necessary)

        ARGCNT = IARGC()

55      CONTINUE

            IF ( ARGCNT .EQ. 0 ) THEN	!  prompt for file name

                FNAME = PROMPTMFILE( 
     &              'Enter logical name for output file',
     &              FSUNKN3, 'OUTFILE', 'M3FAKE' )

            ELSE IF ( ARGCNT .EQ. 1 ) THEN	!  file name from command line

                CALL GETARG( 1, ENVBUF )
                FNAME = ENVBUF( 1:16 )
                IF ( .NOT. OPEN3( FNAME, FSUNKN3, 'M3FAKE' ) ) THEN

                    MESG = 'Could not open "' // FNAME // '"'
                    CALL M3WARN( 'M3FAKE', 0, 0, MESG )
                    IF ( GETYN( 'Prompt for logical file name?', 
     &                          .TRUE. ) ) THEN
                        ARGCNT = 0
                        GO TO  55
                    END IF

                END IF	!  if open3() failed

            ELSE

                CALL M3WARN( 'M3FAKE', 0, 0, 
     &                       'Usage:  "m3fake [file]"' )
                IF ( GETYN( 'Prompt for logical file name?', 
     &                      .TRUE. ) ) THEN
                    ARGCNT = 0
                    GO TO  55
                END IF

            END IF	!  if argcnt 0, 1, or "wrong"
         
        DO  111  T = 1, NSTEPS
        
            CALL FAKESTEP( FNAME, JDATE, JTIME, OPTYPES, FILLVAL )
            CALL NEXTIME ( JDATE, JTIME, TSTEP )

111     CONTINUE


      CALL M3EXIT( 'M3FAKE', 0, 0, 
     &             'Program completed successfully', 0 )

C******************  FORMAT  STATEMENTS   ******************************

C...........   Informational (LOG) message formats... 92xxx

92000	FORMAT( 5X, A )


C...........   Formatted file I/O formats............ 93xxx

93000	FORMAT( A )

C...........   Internal buffering formats............ 94xxx

94000	FORMAT( A, I4, :, A )


C...........   Miscellaneous formats................. 95xxx

95000   FORMAT ( /5X , A , $ )          !  generic prompt format.


        END

