
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        
        SUBROUTINE  XTSTEP ( SIZE,  LAYER, JDATE, JTIME,
     &                       INAME, VNAMEI, ONAME, VNAMEO, LOGDEV )

C***********************************************************************
C  subroutine body starts at line  66
C
C  FUNCTION:
C       Copy this time step of variable VNAME from INAME to ONAME.
C
C  PRECONDITIONS REQUIRED:
C       Valid dates and times JDATE:JTIME
C       f77 MALLOC()-allocation operating environment (such as Sun, SGI)
C
C  SUBROUTINES AND FUNCTIONS CALLED:
C       Models-3 I/O:  M3ERR(), READ3(), WRITE3()
C
C  REVISION  HISTORY:
C       Prototype 1/95 by CJC
C
C***********************************************************************

!DEC$ IF DEFINED (_WIN32)
!DEC$ DEFINE AUTO_ARRAYS 1
!DEC$ ELSE
#ifndef AUTO_ARRAYS
#if __sgi  || __sun || __osf__ || __mips__
#define AUTO_ARRAYS 0
#endif
#if _CRAY || _AIX
#define AUTO_ARRAYS 1
#endif
#endif

#ifndef AUTO_ARRAYS
#error   "Error compiling:  don't know AUTO_ARRAYS"
#endif
!DEC$ ENDIF

C...........   INCLUDES:


        INCLUDE 'PARMS3.EXT'  !  I/O parameter definitions
        INCLUDE 'IODECL3.EXT' !  I/O definitions and declarations


C...........   ARGUMENTS and their descriptions:

        INTEGER         SIZE    ! total array dimensions for this variable
        INTEGER         LAYER   ! layer number to read
        INTEGER         JDATE   ! current model date
        INTEGER         JTIME   ! current model time
        CHARACTER*16    INAME   !  logical name of the  input file
        CHARACTER*16    ONAME   !  logical name of the output file
        CHARACTER*16    VNAMEI  !  vble name (input)
        CHARACTER*16    VNAMEO  !  vble name (output)
        INTEGER         LOGDEV  ! unit number for output


C...........   EXTERNAL FUNCTIONS:

!DEC$ IF DEFINED(_WIN32)
!DEC$ ELSE
#if ! AUTO_ARRAYS
        INTEGER         MALLOC
#endif    /* ! AUTO_ARRAYS */
!DEC$ ENDIF


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        REAL            GRID( SIZE )

!DEC$ IF DEFINED(_WIN32)
!DEC$ ELSE
#if ! AUTO_ARRAYS
	INTEGER         LSIZE  / -1 /
	POINTER         ( P, GRID )

	SAVE            P, LSIZE
#endif    /* ! AUTO_ARRAYS */
!DEC$ ENDIF


C***********************************************************************
C   begin body of subroutine  XTSTEP


!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#if ! AUTO_ARRAYS
	IF ( SIZE .GT. LSIZE ) THEN
	    IF ( LSIZE .GT. 0 )  CALL FREE( P )
	    P = MALLOC( 8 * SIZE )
	    IF ( P .EQ. 0 )
     &           CALL M3ERR( 'XTSTEP', JDATE, JTIME,
     &                       'Memory allocation error',
     &                       .TRUE. )
	    LSIZE = SIZE
	END IF
#endif    /* ! AUTO_ARRAYS */
!DEC$ ENDIF
	
        IF ( READ3( INAME, VNAMEI, LAYER,
     &              JDATE, JTIME, GRID ) ) THEN
           
            IF ( .NOT. WRITE3( ONAME, VNAMEO, 
     &                         JDATE, JTIME, GRID ) ) THEN
               
                CALL M3ERR ( 'M3XTRACT:XTSTEP', JDATE, JTIME,
     &                       'Write failure:  file ' // ONAME //
     &                       ' variable ' // VNAMEO,
     &                       .FALSE. )
               
            END IF              !  if read3() worked, or not
                   
        ELSE                !  read3() failed:
           
            CALL M3ERR ( 'M3XTRACT:XTSTEP', JDATE, JTIME,
     &                   'Read failure:  file ' // INAME //
     &                   ' variable ' // VNAMEI,
     &                   .FALSE. )
           
        END IF              !  if read3() worked, or not

        RETURN

        END

