
C Version "%W% %P% %G% %U%

        SUBROUTINE  MM2FILL( FACTOR, NCOLS, NROWS, NLAYS, AOUT )

C***********************************************************************
C  subroutine body starts at line  59
C
C  FUNCTION:  Fill array AOUT with FACTOR.
C
C  NOTE that MM5-order I subscripts go from south to north, J subscripts
C	go from west to east, and K subscripts go from top to bottom,
C	whereas IOAPI-order C subscripts go from west to east,
C	R subscripts go from south to north, and L subscripts go
C	from bottom to top.
C
C  PRECONDITIONS REQUIRED:
C	ioapi grid fits within the MM5 grid
C
C  SUBROUTINES AND FUNCTIONS CALLED: none
C
C  REVISION  HISTORY:
C	Prototype OCT. 16, 1997 by Carlie J. Coats, Jr., MCNC
C
C***********************************************************************

      IMPLICIT NONE

C...........   ARGUMENTS and their descriptions:

        REAL		FACTOR  !  conversion factor
        INTEGER         NCOLS	!  output dimension
        INTEGER         NROWS	!  " 
        INTEGER         NLAYS	!  "
 	REAL	      	AOUT( NCOLS, NROWS, NLAYS )

C...........   SCRATCH LOCAL VARIABLES and their descriptions:

	INTEGER		C			!  IOAPI col subscript
	INTEGER		R			!  IOAPI row subscript
	INTEGER		L			!  IOAPI lay subscript

C***********************************************************************
C   begin body of subroutine  MM2IO

        DO  L = 1, NLAYS
        DO  R = 1, NROWS
        DO  C = 1, NCOLS
            AOUT( C,R,L ) = FACTOR
        END DO
        END DO
        END DO

        RETURN
        END

